/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "parser.yy" /* yacc.c:339  */
 /* -*- C++ -*- */
/***************************************************************************
                      parser.ypp  -  syntaxical analyzer
                             -------------------
    begin                : Thu May 25 2003
    copyright            : (C) 2003 CEA and Universite Paris Sud
    author               : Gilles Mouchard
    email                : mouchard@lri.fr
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <parser_defs.hh>
#include <vect.hh>
#include <isa.hh>
#include <sourcecode.hh>
#include <action.hh>
#include <comment.hh>
#include <operation.hh>
#include <subdecoder.hh>
#include <variable.hh>
#include <bitfield.hh>
#include <specialization.hh>
#include <scanner.hh>
#include <conststr.hh>
#include <cstdarg>
#include <cstdio>
#include <cstring>
#include <vector>
#include <cstdlib>
  
int yylex();
int yyerror( char const* _err );

static
void
create_action( Operation_t* _operation, ActionProto_t const* _actionproto, SourceCode_t* _actioncode ) {
  Action_t const* prev_action = _operation->action( _actionproto );

  if( prev_action ) {
    Scanner::fileloc.err( "error: action `%s.%s' redefined",
                          _operation->m_symbol.str(), _actionproto->m_symbol.str() );
    
    prev_action->m_fileloc.err( "action `%s.%s' previously defined here",
                                _operation->m_symbol.str(), _actionproto->m_symbol.str() );
    exit( -1 );
  }
  
  _operation->add( new Action_t( _actionproto, _actioncode, Scanner::comments, Scanner::fileloc ) );
}


#line 125 "parser.cc" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_PARSER_HH_INCLUDED
# define YY_YY_PARSER_HH_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOK_ENDL = 258,
    TOK_TAB = 259,
    TOK_QUAD_DOT = 260,
    TOK_ACTION = 261,
    TOK_CONST = 262,
    TOK_CONSTRUCTOR = 263,
    TOK_DECL = 264,
    TOK_DECODER = 265,
    TOK_DESTRUCTOR = 266,
    TOK_GROUP = 267,
    TOK_IMPL = 268,
    TOK_INCLUDE = 269,
    TOK_INHERITANCE = 270,
    TOK_NAMESPACE = 271,
    TOK_OP = 272,
    TOK_REWIND = 273,
    TOK_SET = 274,
    TOK_SEXT = 275,
    TOK_SHL = 276,
    TOK_SHR = 277,
    TOK_SPECIALIZE = 278,
    TOK_STATIC = 279,
    TOK_SUBDECODER = 280,
    TOK_TEMPLATE = 281,
    TOK_VAR = 282,
    TOK_SOURCE_CODE = 283,
    TOK_IDENT = 284,
    TOK_INTEGER = 285,
    TOK_STRING = 286
  };
#endif
/* Tokens.  */
#define TOK_ENDL 258
#define TOK_TAB 259
#define TOK_QUAD_DOT 260
#define TOK_ACTION 261
#define TOK_CONST 262
#define TOK_CONSTRUCTOR 263
#define TOK_DECL 264
#define TOK_DECODER 265
#define TOK_DESTRUCTOR 266
#define TOK_GROUP 267
#define TOK_IMPL 268
#define TOK_INCLUDE 269
#define TOK_INHERITANCE 270
#define TOK_NAMESPACE 271
#define TOK_OP 272
#define TOK_REWIND 273
#define TOK_SET 274
#define TOK_SEXT 275
#define TOK_SHL 276
#define TOK_SHR 277
#define TOK_SPECIALIZE 278
#define TOK_STATIC 279
#define TOK_SUBDECODER 280
#define TOK_TEMPLATE 281
#define TOK_VAR 282
#define TOK_SOURCE_CODE 283
#define TOK_IDENT 284
#define TOK_INTEGER 285
#define TOK_STRING 286

/* Value type.  */


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_PARSER_HH_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 233 "parser.cc" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   158

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  45
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  45
/* YYNRULES -- Number of rules.  */
#define YYNRULES  94
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  187

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   286

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       9,    10,     3,     2,     5,     7,     8,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     4,     2,
      13,     6,    14,    44,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    11,     2,    12,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   150,   150,   152,   152,   156,   160,   167,   196,   199,
     206,   210,   218,   241,   254,   266,   278,   285,   286,   287,
     288,   289,   290,   291,   295,   299,   302,   306,   310,   314,
     315,   320,   321,   325,   329,   332,   341,   345,   348,   360,
     366,   372,   378,   383,   388,   393,   398,   427,   431,   437,
     441,   445,   449,   462,   466,   473,   476,   480,   487,   490,
     497,   500,   504,   511,   515,   521,   547,   553,   557,   564,
     567,   573,   583,   644,   647,   654,   657,   663,   672,   675,
     679,   686,   689,   693,   697,   703,   739,   754,   769,   773,
     779,   785,   792,   829,   833
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "'*'", "':'", "','", "'='", "'-'", "'.'",
  "'('", "')'", "'['", "']'", "'<'", "'>'", "TOK_ENDL", "TOK_TAB",
  "TOK_QUAD_DOT", "TOK_ACTION", "TOK_CONST", "TOK_CONSTRUCTOR", "TOK_DECL",
  "TOK_DECODER", "TOK_DESTRUCTOR", "TOK_GROUP", "TOK_IMPL", "TOK_INCLUDE",
  "TOK_INHERITANCE", "TOK_NAMESPACE", "TOK_OP", "TOK_REWIND", "TOK_SET",
  "TOK_SEXT", "TOK_SHL", "TOK_SHR", "TOK_SPECIALIZE", "TOK_STATIC",
  "TOK_SUBDECODER", "TOK_TEMPLATE", "TOK_VAR", "TOK_SOURCE_CODE",
  "TOK_IDENT", "TOK_INTEGER", "TOK_STRING", "'?'", "$accept", "input",
  "declaration_list", "namespace_list", "subdecoder_instance",
  "template_scheme", "uinteger_list", "subdecoder_class",
  "global_ident_parameter", "global_sourcecode_parameter",
  "global_uinteger_parameter", "template_declaration", "declaration",
  "namespace_declaration", "sourcecode_decl_declaration",
  "sourcecode_impl_declaration", "sourcecode_declaration",
  "bitfield_list_decl", "op_condition", "operation_declaration",
  "bitfield_list", "bitfield", "shift", "sext", "size_modifier",
  "global_inheritance_declaration", "op_var_list_declaration",
  "global_var_list_declaration", "var_list", "var_init", "var",
  "action_proto_declaration", "returns", "constness", "param",
  "param_list", "action_proto_type", "action_declaration",
  "specialization", "user_specialization", "constraint_list", "constraint",
  "include", "group_declaration", "operation_list", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,    42,    58,    44,    61,    45,    46,    40,
      41,    91,    93,    60,    62,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,    63
};
# endif

#define YYPACT_NINF -64

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-64)))

#define YYTABLE_NINF -82

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -64,     6,    22,   -64,   -64,   -64,   -33,   -64,   -16,   -12,
      -5,    -4,   -14,     3,    11,   -64,   -14,    41,    15,    51,
      56,    50,    52,    53,    54,    55,   -64,   -64,   -64,    57,
      58,    59,    37,    60,    61,   -64,   -64,    62,    63,    64,
      65,    67,   -64,   -64,   -64,    69,   -64,   -64,    31,   -64,
      66,    -7,    75,    -9,    45,    82,    83,   -64,   -64,   -25,
     -64,   -64,   -64,   -64,   -64,   -64,   -64,   -64,    46,   -64,
     -64,   -64,    49,   -64,   -64,   -64,    68,    84,    70,   -64,
     -64,   -64,    71,    72,    78,    73,   -64,    -1,    76,    15,
      85,    15,    86,    87,   -64,    74,   -64,    12,    77,   -64,
      89,    13,   -64,   -64,     0,    79,   -64,   -64,    45,   -64,
      91,   -64,    68,    83,    80,    -3,   -64,    90,    81,   -64,
     -64,    88,    71,   -64,    92,   -64,    93,   -64,    95,   -64,
      14,   -64,    96,   -10,    97,   105,    94,   110,     5,   -64,
      99,    45,   -64,   -64,   -64,   -64,   -64,   -64,   -64,   112,
     -64,   111,    98,   100,   101,   102,    -3,   -64,   -64,   113,
      16,   104,   -64,   114,   115,   120,   121,   -64,   -13,   106,
     108,   124,   -64,   -64,   -64,   -64,   -64,   125,   127,   -64,
     109,   -64,   -64,   116,   -64,   129,   -64
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,     0,     2,     1,    17,    82,     0,    83,     0,     0,
       0,     0,     0,     0,     0,    84,     0,     0,     0,    41,
       0,     0,     0,     0,     0,     0,    35,     4,    34,     0,
       0,     0,     0,     0,     0,    31,    30,     0,     0,     0,
       0,     0,    29,    33,    39,     0,    40,    91,     0,     5,
      38,     0,     0,     0,    78,     0,    66,    67,    44,     0,
      22,    21,    18,    19,    20,    27,    28,    26,     0,    23,
      32,    24,    73,    25,    36,    37,     0,    64,     0,    14,
      13,    15,     0,     0,     8,     0,    79,     0,     0,     0,
       0,     0,     0,    43,    74,     0,    93,     0,     0,     6,
       0,     0,    88,    10,     0,     0,     7,    77,     0,    16,
      69,    68,     0,    65,     0,    55,    46,     0,     0,    92,
      63,     0,     0,    86,     0,    12,     0,    80,     0,    71,
       0,    85,     0,     0,     0,     0,     0,     0,     0,    47,
      58,    78,    94,    90,    89,    11,     9,    70,    87,     0,
      53,     0,     0,     0,     0,     0,    55,    42,    59,    60,
       0,     0,    54,     0,     0,     0,     0,    48,     0,     0,
      75,     0,    57,    56,    49,    51,    62,     0,     0,    76,
       0,    52,    61,     0,    72,     0,    50
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -64,   -64,   -64,   130,   -64,   -64,   -64,   -64,   -64,   -64,
     -64,   -64,   -64,   -64,   -64,   -64,   -64,   -64,   -64,   -64,
     -64,   -63,   -64,   -64,   -64,   -64,   -64,   -64,     7,   -64,
      17,   -64,   -64,   -64,    -8,   -40,   -64,   -64,   -64,   -64,
     -64,   -20,   -64,   -64,    36
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,    50,    21,   106,   104,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,   116,    32,    33,
     138,   139,   140,   159,   169,    34,    35,    36,    56,   129,
      57,    37,    95,   180,    86,    87,    38,    39,    40,    41,
     101,   102,    42,    43,    97
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     132,   176,    83,   150,   108,   124,     3,    44,    78,   156,
      90,   133,   125,   109,    91,   157,    92,   118,   122,   118,
     151,   108,   119,   123,   148,    45,   170,    49,    46,   177,
     134,   135,    84,    79,    80,    81,    48,     4,    47,   136,
     -81,   137,     5,     6,    51,     7,     8,     9,    10,    11,
      12,   -45,    52,    13,    54,    58,    55,    14,    15,    16,
      17,    18,    19,    20,    59,    60,    68,    61,    62,    63,
      64,    77,    65,    66,    67,    69,    70,    71,    76,    73,
      74,    72,    75,    78,    82,    85,    88,    93,    89,    94,
      98,   105,   114,   167,   112,   121,   115,   128,   113,   141,
     127,   160,   144,     0,     0,   154,   111,   146,     0,    96,
     152,    99,   100,   107,   103,   117,   110,   120,   153,   126,
     131,   155,   142,   161,   162,     0,   168,   179,   172,   173,
     143,   158,   174,   175,   145,   147,   181,   149,   183,   182,
     163,   186,   164,   165,   166,   171,    53,   178,   130,   184,
       0,     0,     0,     0,     0,     0,     0,     0,   185
};

static const yytype_int16 yycheck[] =
{
       3,    14,    11,    13,     5,     5,     0,    40,    17,     4,
      35,    14,    12,    14,    39,    10,    41,     5,     5,     5,
      30,     5,    10,    10,    10,    41,    10,    41,    40,    42,
      33,    34,    41,    40,    41,    42,    40,    15,    43,    42,
      18,    44,    20,    21,    41,    23,    24,    25,    26,    27,
      28,    29,    41,    31,    13,     4,    41,    35,    36,    37,
      38,    39,    40,    41,     8,    15,    29,    15,    15,    15,
      15,    40,    15,    15,    15,    15,    15,    15,     9,    15,
      15,    18,    15,    17,     9,    40,     4,    41,     5,    40,
       6,    13,     6,   156,     9,     6,     9,     6,    91,     9,
     108,   141,   122,    -1,    -1,    11,    89,    14,    -1,    41,
      13,    41,    41,    40,    42,    41,    40,    40,    13,    40,
      40,    11,    41,    11,    13,    -1,    13,    19,    14,    14,
      42,    32,    12,    12,    42,    40,    12,    41,    11,    14,
      42,    12,    42,    42,    42,    41,    16,    41,   112,    40,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    46,    47,     0,    15,    20,    21,    23,    24,    25,
      26,    27,    28,    31,    35,    36,    37,    38,    39,    40,
      41,    49,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    63,    64,    70,    71,    72,    76,    81,    82,
      83,    84,    87,    88,    40,    41,    40,    43,    40,    41,
      48,    41,    41,    48,    13,    41,    73,    75,     4,     8,
      15,    15,    15,    15,    15,    15,    15,    15,    29,    15,
      15,    15,    18,    15,    15,    15,     9,    40,    17,    40,
      41,    42,     9,    11,    41,    40,    79,    80,     4,     5,
      35,    39,    41,    41,    40,    77,    41,    89,     6,    41,
      41,    85,    86,    42,    51,    13,    50,    40,     5,    14,
      40,    75,     9,    73,     6,     9,    62,    41,     5,    10,
      40,     6,     5,    10,     5,    12,    40,    79,     6,    74,
      89,    40,     3,    14,    33,    34,    42,    44,    65,    66,
      67,     9,    41,    42,    86,    42,    14,    40,    10,    41,
      13,    30,    13,    13,    11,    11,     4,    10,    32,    68,
      80,    11,    13,    42,    42,    42,    42,    66,    13,    69,
      10,    41,    14,    14,    12,    12,    14,    42,    41,    19,
      78,    12,    14,    11,    40,    42,    12
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    45,    46,    47,    47,    48,    48,    49,    50,    50,
      51,    51,    52,    53,    54,    55,    56,    57,    57,    57,
      57,    57,    57,    57,    57,    57,    57,    57,    57,    57,
      57,    57,    57,    57,    57,    57,    57,    57,    58,    59,
      60,    61,    62,    62,    63,    63,    64,    65,    65,    66,
      66,    66,    66,    66,    66,    67,    67,    67,    68,    68,
      69,    69,    69,    70,    70,    71,    72,    73,    73,    74,
      74,    75,    76,    77,    77,    78,    78,    79,    80,    80,
      80,    81,    81,    81,    81,    82,    83,    84,    85,    85,
      86,    87,    88,    89,    89
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     2,     1,     3,     4,     0,     3,
       1,     3,     5,     3,     3,     3,     4,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     1,
       1,     1,     2,     1,     1,     1,     2,     2,     2,     2,
       2,     1,     3,     0,     2,     0,     4,     1,     3,     4,
       7,     4,     5,     2,     3,     0,     4,     4,     0,     1,
       0,     3,     2,     5,     3,     4,     2,     1,     3,     0,
       2,     4,     9,     0,     1,     0,     1,     2,     0,     1,
       3,     0,     1,     1,     1,     5,     5,     6,     1,     3,
       3,     2,     5,     1,     3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 150 "parser.yy" /* yacc.c:1646  */
    { }
#line 1444 "parser.cc" /* yacc.c:1646  */
    break;

  case 4:
#line 152 "parser.yy" /* yacc.c:1646  */
    {}
#line 1450 "parser.cc" /* yacc.c:1646  */
    break;

  case 5:
#line 157 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.string_list) = new StringVect_t( (yyvsp[0].persistent_string) );
}
#line 1458 "parser.cc" /* yacc.c:1646  */
    break;

  case 6:
#line 161 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.string_list) = (yyvsp[-2].string_list)->append( (yyvsp[0].persistent_string) );
}
#line 1466 "parser.cc" /* yacc.c:1646  */
    break;

  case 7:
#line 168 "parser.yy" /* yacc.c:1646  */
    {
  StringVect_t* nmspc_in = (yyvsp[-2].string_list);
  ConstStr_t symbol = ConstStr_t( (yyvsp[-1].persistent_string), Scanner::symbols );
  SourceCode_t* template_scheme = (yyvsp[0].sourcecode);
  
  std::vector<ConstStr_t> nmspc( nmspc_in->size(), ConstStr_t() );
  for( intptr_t idx = nmspc_in->size(); (--idx) >= 0; )
    nmspc[idx] = ConstStr_t( (*nmspc_in)[idx], Scanner::symbols );
  delete nmspc_in;
  
  SDClass_t const* sdclass = Scanner::isa().sdclass( nmspc );
  if( not sdclass ) {
    Scanner::fileloc.err( "error: subdecoder has not been declared" );
    YYABORT;
  }
  
  SDInstance_t const* sdinstance = Scanner::isa().sdinstance( symbol );
  if( sdinstance ) {
    Scanner::fileloc.err( "error: subdecoder instance `%s' redefined", symbol.str() );
    sdinstance->m_fileloc.err( "subdecoder instance `%s' previously defined here", symbol.str() );
    YYABORT;
  }
  
  Scanner::isa().m_sdinstances.append( new SDInstance_t( symbol, template_scheme, sdclass, Scanner::fileloc ) );
}
#line 1496 "parser.cc" /* yacc.c:1646  */
    break;

  case 8:
#line 196 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.sourcecode) = 0;
}
#line 1504 "parser.cc" /* yacc.c:1646  */
    break;

  case 9:
#line 200 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.sourcecode) = (yyvsp[-1].sourcecode);
}
#line 1512 "parser.cc" /* yacc.c:1646  */
    break;

  case 10:
#line 207 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.uint_list) = new UIntVect_t( (yyvsp[0].uinteger) );
}
#line 1520 "parser.cc" /* yacc.c:1646  */
    break;

  case 11:
#line 211 "parser.yy" /* yacc.c:1646  */
    {
  (yyvsp[-2].uint_list)->push_back( (yyvsp[0].uinteger) );
  (yyval.uint_list) = (yyvsp[-2].uint_list);
}
#line 1529 "parser.cc" /* yacc.c:1646  */
    break;

  case 12:
#line 219 "parser.yy" /* yacc.c:1646  */
    {
  StringVect_t* nmspc_in = (yyvsp[-3].string_list);
  UIntVect_t* insnsizes = (yyvsp[-1].uint_list);
  
  std::vector<ConstStr_t> nmspc( nmspc_in->size(), ConstStr_t() );
  for( intptr_t idx = nmspc_in->size(); (--idx) >= 0; )
    nmspc[idx] = ConstStr_t( (*nmspc_in)[idx], Scanner::symbols );
  delete nmspc_in;
  
  SDClass_t const* sdclass = Scanner::isa().sdclass( nmspc );
  
  if( sdclass ) {
    Scanner::fileloc.err( "error: subdecoder class redeclared." );
    sdclass->m_fileloc.err( "subdecoder class previously declared here." );
    YYABORT;
  }
  
  Scanner::isa().m_sdclasses.append( new SDClass_t( nmspc, insnsizes->begin(), insnsizes->end(), Scanner::fileloc ) );
  delete insnsizes;
}
#line 1554 "parser.cc" /* yacc.c:1646  */
    break;

  case 13:
#line 242 "parser.yy" /* yacc.c:1646  */
    {
  ConstStr_t key( (yyvsp[-1].persistent_string), Scanner::symbols );
  ConstStr_t val( (yyvsp[0].persistent_string), Scanner::symbols );
  
  try {
    Scanner::isa().setparam( key, val );
  } catch (Isa::UnknownIdent ui) {
    Scanner::fileloc.err( "error: unknown or illegal ident `%s'.", ui.m_ident.str() );
    YYABORT;
  }
}
#line 1570 "parser.cc" /* yacc.c:1646  */
    break;

  case 14:
#line 255 "parser.yy" /* yacc.c:1646  */
    {
  ConstStr_t key( (yyvsp[-1].persistent_string), Scanner::symbols );
  SourceCode_t* val = (yyvsp[0].sourcecode);
  try {
    Scanner::isa().setparam( key, val );
  } catch (Isa::UnknownIdent ui) {
    Scanner::fileloc.err( "error: unknown or illegal ident `%s'.", ui.m_ident.str() );
    YYABORT;
  }
}
#line 1585 "parser.cc" /* yacc.c:1646  */
    break;

  case 15:
#line 267 "parser.yy" /* yacc.c:1646  */
    {
  ConstStr_t key( (yyvsp[-1].persistent_string), Scanner::symbols );
  unsigned int val = (yyvsp[0].uinteger);
  try {
    Scanner::isa().setparam( key, val );
  } catch (Isa::UnknownIdent ui) {
    Scanner::fileloc.err( "error: unknown or illegal ident `%s'.", ui.m_ident.str() );
    YYABORT;
  }
}
#line 1600 "parser.cc" /* yacc.c:1646  */
    break;

  case 16:
#line 279 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.param_list) = (yyvsp[-1].param_list);
}
#line 1608 "parser.cc" /* yacc.c:1646  */
    break;

  case 17:
#line 285 "parser.yy" /* yacc.c:1646  */
    {}
#line 1614 "parser.cc" /* yacc.c:1646  */
    break;

  case 23:
#line 292 "parser.yy" /* yacc.c:1646  */
    {
  Scanner::isa().m_operations.append( (yyvsp[-1].operation) );
}
#line 1622 "parser.cc" /* yacc.c:1646  */
    break;

  case 24:
#line 296 "parser.yy" /* yacc.c:1646  */
    {
  Scanner::isa().m_actionprotos.push_back( (yyvsp[-1].actionproto) );
}
#line 1630 "parser.cc" /* yacc.c:1646  */
    break;

  case 25:
#line 300 "parser.yy" /* yacc.c:1646  */
    {
}
#line 1637 "parser.cc" /* yacc.c:1646  */
    break;

  case 26:
#line 303 "parser.yy" /* yacc.c:1646  */
    {
  Scanner::isa().m_decl_srccodes.push_back( (yyvsp[-1].sourcecode) );
}
#line 1645 "parser.cc" /* yacc.c:1646  */
    break;

  case 27:
#line 307 "parser.yy" /* yacc.c:1646  */
    {
  Scanner::isa().m_decl_srccodes.push_back( (yyvsp[-1].sourcecode) );
}
#line 1653 "parser.cc" /* yacc.c:1646  */
    break;

  case 28:
#line 311 "parser.yy" /* yacc.c:1646  */
    {
  Scanner::isa().m_impl_srccodes.push_back( (yyvsp[-1].sourcecode) );
}
#line 1661 "parser.cc" /* yacc.c:1646  */
    break;

  case 29:
#line 314 "parser.yy" /* yacc.c:1646  */
    {}
#line 1667 "parser.cc" /* yacc.c:1646  */
    break;

  case 30:
#line 316 "parser.yy" /* yacc.c:1646  */
    {
  Scanner::isa().m_vars.append( *(yyvsp[0].variable_list) );
  delete (yyvsp[0].variable_list);
}
#line 1676 "parser.cc" /* yacc.c:1646  */
    break;

  case 31:
#line 320 "parser.yy" /* yacc.c:1646  */
    {}
#line 1682 "parser.cc" /* yacc.c:1646  */
    break;

  case 32:
#line 322 "parser.yy" /* yacc.c:1646  */
    {
  Scanner::isa().m_inheritances.push_back( (yyvsp[-1].inheritance) );
}
#line 1690 "parser.cc" /* yacc.c:1646  */
    break;

  case 33:
#line 326 "parser.yy" /* yacc.c:1646  */
    {
  Scanner::isa().m_groups.push_back( (yyvsp[0].group) );
}
#line 1698 "parser.cc" /* yacc.c:1646  */
    break;

  case 34:
#line 330 "parser.yy" /* yacc.c:1646  */
    {
}
#line 1705 "parser.cc" /* yacc.c:1646  */
    break;

  case 35:
#line 333 "parser.yy" /* yacc.c:1646  */
    {
  if( not Scanner::isa().m_tparams.empty() ) {
    Scanner::fileloc.err( "error: template parameters defined more than once" );
    YYABORT;
  }
  Scanner::isa().m_tparams = *(yyvsp[0].param_list);
  delete (yyvsp[0].param_list);
}
#line 1718 "parser.cc" /* yacc.c:1646  */
    break;

  case 36:
#line 342 "parser.yy" /* yacc.c:1646  */
    {
  Scanner::isa().m_specializations.push_back( (yyvsp[-1].specialization) );
}
#line 1726 "parser.cc" /* yacc.c:1646  */
    break;

  case 37:
#line 345 "parser.yy" /* yacc.c:1646  */
    {}
#line 1732 "parser.cc" /* yacc.c:1646  */
    break;

  case 38:
#line 349 "parser.yy" /* yacc.c:1646  */
    {
  StringVect_t* nmspc = (yyvsp[0].string_list);
  
  for( StringVect_t::const_iterator ident = nmspc->begin(); ident != nmspc->end(); ++ident ) {
    Scanner::isa().m_namespace.push_back( ConstStr_t( *ident, Scanner::symbols ) );
  }
  
  delete nmspc;
}
#line 1746 "parser.cc" /* yacc.c:1646  */
    break;

  case 39:
#line 361 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.sourcecode) = (yyvsp[0].sourcecode);
}
#line 1754 "parser.cc" /* yacc.c:1646  */
    break;

  case 40:
#line 367 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.sourcecode) = (yyvsp[0].sourcecode);
}
#line 1762 "parser.cc" /* yacc.c:1646  */
    break;

  case 41:
#line 373 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.sourcecode) = (yyvsp[0].sourcecode);
}
#line 1770 "parser.cc" /* yacc.c:1646  */
    break;

  case 42:
#line 379 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.bitfield_list) = (yyvsp[-1].bitfield_list);
}
#line 1778 "parser.cc" /* yacc.c:1646  */
    break;

  case 43:
#line 383 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.bitfield_list) = 0;
}
#line 1786 "parser.cc" /* yacc.c:1646  */
    break;

  case 44:
#line 389 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.sourcecode) = (yyvsp[-1].sourcecode);
}
#line 1794 "parser.cc" /* yacc.c:1646  */
    break;

  case 45:
#line 393 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.sourcecode) = 0;
}
#line 1802 "parser.cc" /* yacc.c:1646  */
    break;

  case 46:
#line 399 "parser.yy" /* yacc.c:1646  */
    {
  SourceCode_t*       op_cond = (yyvsp[-3].sourcecode);
  ConstStr_t          symbol = ConstStr_t( (yyvsp[-1].persistent_string), Scanner::symbols );
  Vect_t<BitField_t>* bitfields = (yyvsp[0].bitfield_list);
  
  {
    Operation_t const* prev_op = Scanner::isa().operation( symbol );
    if( prev_op ) {
      Scanner::fileloc.err( "error: operation `%s' redefined", symbol.str() );
      prev_op->m_fileloc.err( "operation `%s' previously defined here", symbol.str() );
      YYABORT;
    }
    
    Group_t const* prev_grp = Scanner::isa().group( symbol );
    if( prev_grp ) {
      Scanner::fileloc.err( "error: operation `%s' redefined", symbol.str() );
      prev_grp->m_fileloc.err( "group `%s' previously defined here", symbol.str() );
    }
  }

  Operation_t* operation = new Operation_t( symbol, *bitfields, Scanner::comments, op_cond, Scanner::fileloc );
  delete bitfields;
  Scanner::comments.clear();

  (yyval.operation) = operation;
}
#line 1833 "parser.cc" /* yacc.c:1646  */
    break;

  case 47:
#line 428 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.bitfield_list) = new Vect_t<BitField_t>( (yyvsp[0].bitfield) );
}
#line 1841 "parser.cc" /* yacc.c:1646  */
    break;

  case 48:
#line 432 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.bitfield_list) = (yyvsp[-2].bitfield_list)->append( (yyvsp[0].bitfield) );
}
#line 1849 "parser.cc" /* yacc.c:1646  */
    break;

  case 49:
#line 438 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.bitfield) = new OpcodeBitField_t( (yyvsp[-1].uinteger), (yyvsp[-3].uinteger) );
}
#line 1857 "parser.cc" /* yacc.c:1646  */
    break;

  case 50:
#line 442 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.bitfield) = new OperandBitField_t( (yyvsp[-1].uinteger), ConstStr_t( (yyvsp[-3].persistent_string), Scanner::symbols ), (yyvsp[-6].sinteger), (yyvsp[-4].uinteger), (yyvsp[-5].boolean) );
}
#line 1865 "parser.cc" /* yacc.c:1646  */
    break;

  case 51:
#line 446 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.bitfield) = new UnusedBitField_t( (yyvsp[-1].uinteger) );
}
#line 1873 "parser.cc" /* yacc.c:1646  */
    break;

  case 52:
#line 450 "parser.yy" /* yacc.c:1646  */
    {
  ConstStr_t symbol = ConstStr_t( (yyvsp[-3].persistent_string), Scanner::symbols );
  ConstStr_t sdinstance_symbol = ConstStr_t( (yyvsp[-1].persistent_string), Scanner::symbols );
  SDInstance_t const* sdinstance = Scanner::isa().sdinstance( sdinstance_symbol );
  
  if( not sdinstance ) {
    Scanner::fileloc.err( "error: subdecoder instance `%s' not declared", sdinstance_symbol.str() );
    YYABORT;
  }
  
  (yyval.bitfield) = new SubOpBitField_t( symbol, sdinstance );
}
#line 1890 "parser.cc" /* yacc.c:1646  */
    break;

  case 53:
#line 463 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.bitfield) = new SeparatorBitField_t( false );
}
#line 1898 "parser.cc" /* yacc.c:1646  */
    break;

  case 54:
#line 467 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.bitfield) = new SeparatorBitField_t( true );
}
#line 1906 "parser.cc" /* yacc.c:1646  */
    break;

  case 55:
#line 473 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.sinteger) = 0;
}
#line 1914 "parser.cc" /* yacc.c:1646  */
    break;

  case 56:
#line 477 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.sinteger) = (yyvsp[-1].uinteger);
}
#line 1922 "parser.cc" /* yacc.c:1646  */
    break;

  case 57:
#line 481 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.sinteger) = -(yyvsp[-1].uinteger);
}
#line 1930 "parser.cc" /* yacc.c:1646  */
    break;

  case 58:
#line 487 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.boolean) = false;
}
#line 1938 "parser.cc" /* yacc.c:1646  */
    break;

  case 59:
#line 491 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.boolean) = true;
}
#line 1946 "parser.cc" /* yacc.c:1646  */
    break;

  case 60:
#line 497 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.uinteger) = 0;
}
#line 1954 "parser.cc" /* yacc.c:1646  */
    break;

  case 61:
#line 501 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.uinteger) = (yyvsp[-1].uinteger);
}
#line 1962 "parser.cc" /* yacc.c:1646  */
    break;

  case 62:
#line 505 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.uinteger) = 0;
}
#line 1970 "parser.cc" /* yacc.c:1646  */
    break;

  case 63:
#line 512 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.inheritance) = new Inheritance_t( (yyvsp[-3].sourcecode), (yyvsp[-2].sourcecode), (yyvsp[0].sourcecode) );
}
#line 1978 "parser.cc" /* yacc.c:1646  */
    break;

  case 64:
#line 516 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.inheritance) = new Inheritance_t( (yyvsp[-1].sourcecode), (yyvsp[0].sourcecode), 0 );
}
#line 1986 "parser.cc" /* yacc.c:1646  */
    break;

  case 65:
#line 522 "parser.yy" /* yacc.c:1646  */
    {
  ConstStr_t    target_symbol = ConstStr_t( (yyvsp[-3].persistent_string), Scanner::symbols );
  Vect_t<Variable_t>* var_list = (yyvsp[0].variable_list);
  
  /* Target symbol points to either an operation or a group */
  Operation_t* operation = Scanner::isa().operation( target_symbol );
  if( operation ) {
    /* Target symbol points to an operation */
    operation->m_variables.append( *var_list );
  } else {
    Group_t* group = Scanner::isa().group( target_symbol );
    if( group ) {
      /* Target symbol points to a group */
      for( Vect_t<Operation_t>::iterator gop = group->m_operations.begin(); gop < group->m_operations.end(); ++ gop )
        (**gop).m_variables.append( *var_list );
    } else {
      /* Target symbol doesn't point to anything */
      Scanner::fileloc.err( "error: undefined operation or group `%s'", target_symbol.str() );
      YYABORT;
    }
  }
  delete var_list;
}
#line 2014 "parser.cc" /* yacc.c:1646  */
    break;

  case 66:
#line 548 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.variable_list) = (yyvsp[0].variable_list);
}
#line 2022 "parser.cc" /* yacc.c:1646  */
    break;

  case 67:
#line 554 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.variable_list) = new Vect_t<Variable_t>( (yyvsp[0].variable) );
}
#line 2030 "parser.cc" /* yacc.c:1646  */
    break;

  case 68:
#line 558 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.variable_list) = (yyvsp[-2].variable_list)->append( (yyvsp[0].variable) );
}
#line 2038 "parser.cc" /* yacc.c:1646  */
    break;

  case 69:
#line 564 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.sourcecode) = 0;
}
#line 2046 "parser.cc" /* yacc.c:1646  */
    break;

  case 70:
#line 568 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.sourcecode) = (yyvsp[0].sourcecode);
}
#line 2054 "parser.cc" /* yacc.c:1646  */
    break;

  case 71:
#line 574 "parser.yy" /* yacc.c:1646  */
    {
  ConstStr_t     symbol = ConstStr_t( (yyvsp[-3].persistent_string), Scanner::symbols );
  SourceCode_t*  c_type = (yyvsp[-1].sourcecode);
  SourceCode_t*  c_init = (yyvsp[0].sourcecode);
  
  (yyval.variable) = new Variable_t( symbol, c_type, c_init );
}
#line 2066 "parser.cc" /* yacc.c:1646  */
    break;

  case 72:
#line 584 "parser.yy" /* yacc.c:1646  */
    {
  ActionProto_t::type_t action_proto_type = ActionProto_t::type_t( (yyvsp[-8].sinteger) );
  SourceCode_t*         returns = (yyvsp[-6].sourcecode);
  ConstStr_t            symbol = ConstStr_t( (yyvsp[-5].persistent_string), Scanner::symbols );
  Vect_t<CodePair_t>*   param_list = (yyvsp[-3].param_list);
  SourceCode_t*         default_sourcecode = (yyvsp[0].sourcecode);

  { /* action protype name should be unique */
    ActionProto_t const*  prev_proto = Scanner::isa().actionproto( symbol );
    if( prev_proto ) {
      Scanner::fileloc.err( "error: action prototype `%s' redefined", prev_proto->m_symbol.str() );
      prev_proto->m_fileloc.err( "action prototype `%s' previously defined here", prev_proto->m_symbol.str() );
      YYABORT;
    }
  }
    
  if( returns ) {
    switch( action_proto_type ) {
    case ActionProto_t::Constructor:
      Scanner::fileloc.err( "error: constructor action prototype `%s' must not have a return type (%s)",
                symbol.str(), returns->m_content.str() );
      YYABORT;
      break;
    case ActionProto_t::Destructor:
      Scanner::fileloc.err( "error: destructor action prototype `%s' must not have a return type (%s)",
                symbol.str(), returns->m_content.str() );
      YYABORT;
      break;
    default: break;
    }
  }
  
  if( param_list )
  {
    switch( action_proto_type ) {
    case ActionProto_t::Constructor:
      Scanner::fileloc.err( "error: constructor action prototype `%s' must not take any arguments", symbol.str() );
      YYABORT;
      break;
    case ActionProto_t::Static:
      Scanner::fileloc.err( "error: static action prototype `%s' must not take any arguments", symbol.str() );
      YYABORT;
      break;
    case ActionProto_t::Destructor:
      Scanner::fileloc.err( "error: destructor action prototype `%s' must not take any arguments", symbol.str() );
      YYABORT;
      break;
    default: break;
    }
  }
  
  ActionProto_t* actionproto =
    new ActionProto_t( action_proto_type, symbol, returns, *param_list, (yyvsp[-1].boolean), default_sourcecode, Scanner::comments, Scanner::fileloc );
  Scanner::comments.clear();
  delete param_list;
  (yyval.actionproto) = actionproto;
}
#line 2128 "parser.cc" /* yacc.c:1646  */
    break;

  case 73:
#line 644 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.sourcecode) = 0;
}
#line 2136 "parser.cc" /* yacc.c:1646  */
    break;

  case 74:
#line 648 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.sourcecode) = (yyvsp[0].sourcecode);
}
#line 2144 "parser.cc" /* yacc.c:1646  */
    break;

  case 75:
#line 654 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.boolean) = false;
}
#line 2152 "parser.cc" /* yacc.c:1646  */
    break;

  case 76:
#line 658 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.boolean) = true;
}
#line 2160 "parser.cc" /* yacc.c:1646  */
    break;

  case 77:
#line 664 "parser.yy" /* yacc.c:1646  */
    {
  SourceCode_t *c_type = (yyvsp[-1].sourcecode);
  SourceCode_t *c_symbol = (yyvsp[0].sourcecode);
  (yyval.param) = new CodePair_t( c_type, c_symbol );
}
#line 2170 "parser.cc" /* yacc.c:1646  */
    break;

  case 78:
#line 672 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.param_list) = 0;
}
#line 2178 "parser.cc" /* yacc.c:1646  */
    break;

  case 79:
#line 676 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.param_list) = new Vect_t<CodePair_t>( (yyvsp[0].param) );
}
#line 2186 "parser.cc" /* yacc.c:1646  */
    break;

  case 80:
#line 680 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.param_list) = (yyvsp[-2].param_list)->append( (yyvsp[0].param) );
}
#line 2194 "parser.cc" /* yacc.c:1646  */
    break;

  case 81:
#line 686 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.sinteger) = ActionProto_t::Common;
}
#line 2202 "parser.cc" /* yacc.c:1646  */
    break;

  case 82:
#line 690 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.sinteger) = ActionProto_t::Constructor;
}
#line 2210 "parser.cc" /* yacc.c:1646  */
    break;

  case 83:
#line 694 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.sinteger) = ActionProto_t::Destructor;
}
#line 2218 "parser.cc" /* yacc.c:1646  */
    break;

  case 84:
#line 698 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.sinteger) = ActionProto_t::Static;
}
#line 2226 "parser.cc" /* yacc.c:1646  */
    break;

  case 85:
#line 704 "parser.yy" /* yacc.c:1646  */
    {
  ConstStr_t    target_symbol = ConstStr_t( (yyvsp[-4].persistent_string), Scanner::symbols );
  ConstStr_t    action_proto_symbol = ConstStr_t( (yyvsp[-2].persistent_string), Scanner::symbols );
  SourceCode_t* actioncode = (yyvsp[0].sourcecode);
  
  /* Actions belongs to an action prototype */
  ActionProto_t const* actionproto = Scanner::isa().actionproto( action_proto_symbol );

  if( not actionproto ) {
    Scanner::fileloc.err( "error: undefined action prototype `%s'", action_proto_symbol.str() );
    YYABORT;
  }
  
  /* Target symbol points to either an operation or a group */
  Operation_t* operation = Scanner::isa().operation( target_symbol );
  if( operation ) {
    /* Target symbol points to an operation */
    create_action( operation, actionproto, actioncode );
  } else {
    Group_t* group = Scanner::isa().group( target_symbol );
    if( group ) {
      /* Target symbol points to a group */
      for( Vect_t<Operation_t>::iterator gop = group->m_operations.begin(); gop < group->m_operations.end(); ++ gop )
        create_action( *gop, actionproto, actioncode );
    } else {
      /* Target symbol doesn't point to anything */
      Scanner::fileloc.err( "error: undefined operation or group `%s'", target_symbol.str() );
      YYABORT;
    }
  }
  
  Scanner::comments.clear();
}
#line 2264 "parser.cc" /* yacc.c:1646  */
    break;

  case 86:
#line 740 "parser.yy" /* yacc.c:1646  */
    {
  ConstStr_t            symbol = ConstStr_t( (yyvsp[-3].persistent_string), Scanner::symbols );
  Vect_t<Constraint_t>* constraint_list = (yyvsp[-1].constraint_list);
  Operation_t*          operation = Scanner::isa().operation( symbol );
  if( not operation ) {
    Scanner::fileloc.err( "error: operation `%s' not defined", symbol.str() );
    YYABORT;
  }
  
  (yyval.specialization) = new Specialization_t( operation, *constraint_list );
  delete constraint_list;
}
#line 2281 "parser.cc" /* yacc.c:1646  */
    break;

  case 87:
#line 755 "parser.yy" /* yacc.c:1646  */
    {
  StringVect_t const* oplist = (yyvsp[-1].string_list);
  Scanner::isa().m_user_orderings.push_back( Isa::Ordering() );
  Isa::Ordering& order = Scanner::isa().m_user_orderings.back();
  order.fileloc = Scanner::fileloc;
  order.symbols.reserve( oplist->size() + 1 );
  order.symbols.push_back( ConstStr_t( (yyvsp[-5].persistent_string), Scanner::symbols ) );
  for (StringVect_t::const_iterator itr = oplist->begin(), end = oplist->end(); itr != end; ++itr)
    { order.symbols.push_back( ConstStr_t( *itr, Scanner::symbols ) ); }
  delete oplist;
}
#line 2297 "parser.cc" /* yacc.c:1646  */
    break;

  case 88:
#line 770 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.constraint_list) = new Vect_t<Constraint_t>( (yyvsp[0].constraint) );
}
#line 2305 "parser.cc" /* yacc.c:1646  */
    break;

  case 89:
#line 774 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.constraint_list) = (yyvsp[-2].constraint_list)->append( (yyvsp[0].constraint) );
}
#line 2313 "parser.cc" /* yacc.c:1646  */
    break;

  case 90:
#line 780 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.constraint) = new Constraint_t( ConstStr_t( (yyvsp[-2].persistent_string), Scanner::symbols ), (yyvsp[0].uinteger) );
}
#line 2321 "parser.cc" /* yacc.c:1646  */
    break;

  case 91:
#line 786 "parser.yy" /* yacc.c:1646  */
    {
  if( not Scanner::include( (yyvsp[0].volatile_string) ) )
    YYABORT;
}
#line 2330 "parser.cc" /* yacc.c:1646  */
    break;

  case 92:
#line 793 "parser.yy" /* yacc.c:1646  */
    {
  ConstStr_t           group_symbol = ConstStr_t( (yyvsp[-3].persistent_string), Scanner::symbols );
  StringVect_t*        oplist = (yyvsp[-1].string_list);
  
  { /* Operations and groups name should not conflict */
    Operation_t* prev_op = Scanner::isa().operation( group_symbol );
    if (prev_op) {
      Scanner::fileloc.err( "error: group name conflicts with operation `%s'", group_symbol.str() );
      prev_op->m_fileloc.err( "operation `%s' previously defined here", group_symbol.str() );
      YYABORT;
    }
    
    Group_t* prev_grp = Scanner::isa().group( group_symbol );
    if (prev_grp) {
      Scanner::fileloc.err( "error: group `%s' redefined", group_symbol.str() );
      prev_grp->m_fileloc.err( "group `%s' previously defined here", group_symbol.str() );
      YYABORT;
    }
  }
  
  Group_t* res = new Group_t( group_symbol, Scanner::fileloc );
  for (StringVect_t::const_iterator itr = oplist->begin(), end = oplist->end(); itr != end; ++itr) {
    ConstStr_t symbol( *itr, Scanner::symbols );
    if (not Scanner::isa().operations( symbol, res->m_operations ))
      {
        Scanner::fileloc.err( "error: undefined operation or group `%s'", symbol.str() );
        YYABORT;
      }
  }
  delete oplist;
  
  (yyval.group) = res;
}
#line 2368 "parser.cc" /* yacc.c:1646  */
    break;

  case 93:
#line 830 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.string_list) = new StringVect_t( (yyvsp[0].persistent_string) );
}
#line 2376 "parser.cc" /* yacc.c:1646  */
    break;

  case 94:
#line 834 "parser.yy" /* yacc.c:1646  */
    {
  (yyval.string_list) = (yyvsp[-2].string_list)->append( (yyvsp[0].persistent_string) );
}
#line 2384 "parser.cc" /* yacc.c:1646  */
    break;


#line 2388 "parser.cc" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 839 "parser.yy" /* yacc.c:1906  */


int yyerror( char const* _err ) { Scanner::fileloc.err( "%s! unexpected %s\n", _err, Scanner::tokenname( yychar ).str() ); return 1; }
